//= require <dSS/grid/ModulatorPanel>
Ext.namespace('dSS', 'dSS.system', 'dSS.grid');

dSS.system.dSMOverview = Ext.extend(Ext.Panel, {
    initComponent: function() {

        Ext.apply(this, {
            layout: 'border',
            items: [
            {
                xtype: 'dssmodulatorpanel',
                ref: 'modulatorPanel',
                region: 'north',
                split: true
            },
            {
                xtype: 'dssdevicepanel',
                region: 'center',
                featureConfig: dSS.config.FeatureConfig.CIRCUIT
            }]
        });

        dSS.system.dSMOverview.superclass.initComponent.apply(this, arguments);

        this.on('activate', function() {
            if (this.ledQueryTask === undefined) {
                this.ledQueryTask = new Ext.util.DelayedTask(
                    this.getLedInfo.createDelegate(this), this);
            }
            if (dSS.config.firstLoad === true) {
                this.ledQueryTask.delay(15000);
            } else {
                this.ledQueryTask.delay(1000);
            }
            this.modulatorPanel.setInitialSelection();
        },
        this);

        this.on('deactivate', function() {
                if (this.ledQueryTask !== undefined) {
                    this.ledQueryTask.cancel();
                }
            },
            this);
        this.on('afterrender', function() {
            if (dSS.config.firstLoad === true) {
                dSS.data.Loader.load();
                dSS.config.firstLoad = false;
            }
        },
        this);
    },
    getLedInfo: function() {
        if (dSA.module !== true) {
            return;
        }

        if (this.isVisible() !== true) {
            return;
        }

        var store = dSS.data.Loader.getModulatorStore();

        var f = function(success, data) {
            if (success === false) {
                dSS.util.updateDSMLEDInfo(store);
            } else {
                dSS.util.updateDSMLEDInfo(store, data.dsms);
            }

            if (this.isVisible() === true) {
                if (this.ledQueryTask == undefined) {
                    this.ledQueryTask = new Ext.util.DelayedTask(
                        this.getLedInfo.createDelegate(this), this);
                }
                this.ledQueryTask.delay(15000);
            }
        }.createDelegate(this);
        dSA.functions.GetDSMLED("", f, true);
    }
});

Ext.reg('dsmoverviewpanel', dSS.system.dSMOverview);

